## libxc 4.2.3

=== CMakeLists.txt ===
cmake_policy(SET CMP0048 NEW)  # project_VERSION* variables populated from project(... VERSION x.x.x) string
project(Libxc
        VERSION 4.2.3
        LANGUAGES C)
set(Libxc_AUTHORS      "Miguel A.L. Marques and others")
set(Libxc_DESCRIPTION  "Exchange-correlation functionals for density-functional theory")
set(Libxc_EMAIL        "libxc@tddft.org")
set(Libxc_URL          "http://www.tddft.org/programs/Libxc")
set(Libxc_LICENSE      "Mozilla Public License, version 2.0 (MPL-2.0)")

cmake_minimum_required(VERSION 3.0)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

################################### Options ####################################
include(psi4OptionsTools)
option_with_default(CMAKE_BUILD_TYPE "Build type" Release)
option_with_print(BUILD_SHARED_LIBS "Build final library as shared, not static" OFF)
option_with_print(BUILD_TESTING "Compile the testing infrastructure" ON)
option_with_default(BUILD_FPIC "Libraries will be compiled with position independent code" ON)
if((${BUILD_SHARED_LIBS}) AND NOT ${BUILD_FPIC})
    message(FATAL_ERROR "BUILD_SHARED_LIBS ON and BUILD_FPIC OFF are incompatible, as shared library requires position independent code")
endif()
option_with_default(NAMESPACE_INSTALL_INCLUDEDIR "Location within CMAKE_INSTALL_INCLUDEDIR to which headers are installed. Psi4 wants namespace (e.g., /libxc)" /)
option_with_print(ENABLE_GENERIC "Enable mostly static linking in shared library" OFF)
option_with_flags(ENABLE_XHOST "Enable processor-specific optimization" ON
  "-xHost" "-march=native")
option_with_print(ENABLE_FORTRAN "Build Fortran 90 interface" OFF)
option_with_print(ENABLE_FORTRAN03 "Build Fortran 2003 interface" OFF)
if((${ENABLE_FORTRAN03}) AND NOT ${ENABLE_FORTRAN})
    message(FATAL_ERROR "ENABLE_FORTRAN must be enabled if ENABLE_FORTRAN03 is enabled!")
endif()

######################### Process & Validate Options ###########################
include(autocmake_safeguards)
include(custom_static_library)

################################# Main Project #################################
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(PN ${PROJECT_NAME})

# link -lm only if necessary
find_package(StandardMathLibraryC)

# <<<  Build  >>>

# repurpose xc_version from Make for CMake
set(VERSION ${PROJECT_VERSION})
set(XC_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set(XC_MINOR_VERSION ${PROJECT_VERSION_MINOR})
set(XC_MICRO_VERSION ${PROJECT_VERSION_PATCH})
configure_file(xc_version.h.in xc_version.h @ONLY)

# create dummy config.h
configure_file(config.h.cmake.in config.h @ONLY)
configure_file(cmake/libxc.pc.in libxc.pc @ONLY)

# extract project soversion from source
file(STRINGS "configure.ac" _libxc_configure_ac
     REGEX "XC_(CURRENT|REVISION|AGE)=")
foreach(ver ${_libxc_configure_ac})
  if (ver MATCHES "XC_(CURRENT|REVISION|AGE)=+([^ ]+)$")
    set(XC_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
  endif()
endforeach()
set(${PROJECT_NAME}_SOVERSION ${XC_CURRENT}:${XC_REVISION}:${XC_AGE})
message(STATUS "Libxc SO ${${PROJECT_NAME}_SOVERSION}")

set(raw_sources_list
bessel.c
expint_e1.c
func_info.c
functionals.c
gga.c
gga_c_am05.c
gga_c_bcgp.c
gga_c_bmk.c
gga_c_cs1.c
gga_c_ft97.c
gga_c_gapc.c
gga_c_gaploc.c
gga_c_hcth_a.c
gga_c_lm.c
gga_c_lyp.c
gga_c_op_b88.c
gga_c_op_g96.c
gga_c_op_pbe.c
gga_c_op_pw91.c
gga_c_op_xalpha.c
gga_c_optc.c
gga_c_p86.c
gga_c_pbe.c
gga_c_pbeloc.c
gga_c_pw91.c
gga_c_q2d.c
gga_c_regtpss.c
gga_c_revtca.c
gga_c_scan_e0.c
gga_c_sg4.c
gga_c_sogga11.c
gga_c_tca.c
gga_c_w94.c
gga_c_wi.c
gga_c_wl.c
gga_c_zpbeint.c
gga_c_zvpbeint.c
gga_k_dk.c
gga_k_meyer.c
gga_k_ol1.c
gga_k_ol2.c
gga_k_pearson.c
gga_k_tflw.c
gga_k_thakkar.c
gga_k_exp4.c
gga_x_2d_b86.c
gga_x_2d_b86_mgc.c
gga_x_2d_b88.c
gga_x_2d_pbe.c
gga_x_airy.c
gga_x_ak13.c
gga_x_am05.c
gga_x_b86.c
gga_x_b88.c
gga_x_bayesian.c
gga_x_beefvdw.c
gga_x_bpccac.c
gga_x_c09x.c
gga_x_cap.c
gga_x_chachiyo.c
gga_x_dk87.c
gga_x_ev93.c
gga_x_ft97.c
gga_x_g96.c
gga_x_gg99.c
gga_x_hcth_a.c
gga_x_herman.c
gga_x_hjs.c
gga_x_hjs_b88_v2.c
gga_x_htbs.c
gga_x_ityh.c
gga_x_kt.c
gga_x_lag.c
gga_x_lb.c
gga_x_lg93.c
gga_x_lv_rpw86.c
gga_x_mpbe.c
gga_x_n12.c
gga_x_optx.c
gga_x_pbe.c
gga_x_pbea.c
gga_x_pbeint.c
gga_x_pbepow.c
gga_x_pbetrans.c
gga_x_pw86.c
gga_x_pw91.c
gga_x_q2d.c
gga_x_rge2.c
gga_x_rpbe.c
gga_x_sfat.c
gga_x_sg4.c
gga_x_sogga11.c
gga_x_ssb_sw.c
gga_x_vmt.c
gga_x_vmt84.c
gga_x_wc.c
gga_x_wpbeh.c
gga_xc_1w.c
gga_xc_b97.c
gga_xc_edf1.c
gga_xc_oblyp_d.c
gga_xc_th1.c
gga_xc_th2.c
gga_xc_th3.c
gga_xc_vv10.c
hyb_gga_xc_b1wc.c
hyb_gga_xc_b3lyp.c
hyb_gga_xc_cam_b3lyp.c
hyb_gga_xc_camy_b3lyp.c
hyb_gga_xc_camy_blyp.c
hyb_gga_xc_edf2.c
hyb_gga_xc_hse.c
hyb_gga_xc_lcy_blyp.c
hyb_gga_xc_lcy_pbe.c
hyb_gga_xc_o3lyp.c
hyb_gga_xc_pbeh.c
hyb_gga_xc_wb97.c
hyb_mgga_x_dldf.c
hyb_mgga_x_m05.c
hyb_mgga_x_mvsh.c
hyb_mgga_xc_b88b95.c
hyb_mgga_xc_kcis.c
hyb_mgga_xc_tpssh.c
hyb_mgga_xc_wb97mv.c
integrate.c
lda.c
lda_c_1d_csc.c
lda_c_1d_loos.c
lda_c_2d_amgb.c
lda_c_2d_prm.c
lda_c_chachiyo.c
lda_c_gombas.c
lda_c_hl.c
lda_c_lp96.c
lda_c_ml1.c
lda_c_pk09.c
lda_c_pw.c
lda_c_pz.c
lda_c_rc04.c
lda_c_rpa.c
lda_c_vwn.c
lda_c_vwn_1.c
lda_c_vwn_2.c
lda_c_vwn_3.c
lda_c_vwn_4.c
lda_c_vwn_rpa.c
lda_c_wigner.c
lda_c_gk72.c
lda_k_tf.c
lda_k_zlp.c
lda_x.c
lda_x_1d.c
lda_x_2d.c
lda_x_erf.c
lda_x_rel.c
lda_xc_1d_ehwlrg.c
lda_xc_ksdt.c
lda_xc_teter93.c
lda_xc_zlp.c
mgga.c
mgga_c_b88.c
mgga_c_bc95.c
mgga_c_cs.c
mgga_c_kcis.c
mgga_xc_lp90.c
mgga_c_m05.c
mgga_c_m06l.c
mgga_c_m08.c
mgga_c_pkzb.c
mgga_c_revscan.c
mgga_c_revtpss.c
mgga_c_scan.c
mgga_c_tpss.c
mgga_c_tpssloc.c
mgga_c_vsxc.c
mgga_k_pc07.c
mgga_x_2d_prhg07.c
mgga_x_br89.c
mgga_x_br89_explicit.c
mgga_x_gvt4.c
mgga_x_gx.c
mgga_x_lta.c
mgga_x_m06l.c
mgga_x_m08.c
mgga_x_m11.c
mgga_x_m11_l.c
mgga_x_mbeef.c
mgga_x_mbeefvdw.c
mgga_x_mk00.c
mgga_x_mn12.c
mgga_x_ms.c
mgga_x_mvs.c
mgga_x_pbe_gx.c
mgga_x_pkzb.c
mgga_x_sa_tpss.c
mgga_x_scan.c
mgga_x_tau_hcth.c
mgga_x_tm.c
mgga_x_tpss.c
mgga_x_vt84.c
mgga_xc_b97mv.c
mgga_xc_cc06.c
mgga_xc_hle17.c
mgga_xc_otpss_d.c
mgga_xc_zlp.c
mgga_xc_b98.c
mix_func.c
references.c
special_functions.c
util.c
version.c
)

set(src_prefix "src/")
string(REGEX REPLACE "([^;]+)" "${src_prefix}\\1" sources_list "${raw_sources_list}")

# when headers namespaced, xc_version include in xc.h needs to be local, not
#   system to be found
file(READ ${src_prefix}xc.h _src_contents)
string(REPLACE "<xc_version.h>" "\"xc_version.h\"" _quoted_src "${_src_contents}")
file(WRITE ${PROJECT_BINARY_DIR}/${src_prefix}xc.h "${_quoted_src}")

# STATIC/SHARED on below governed by BUILD_SHARED_LIBS
add_library(xc ${sources_list})
target_link_libraries(xc INTERFACE ${STANDARD_MATH_LIBRARY})
set_target_properties(xc PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC}
                                    COMPILE_FLAGS "-std=c99"
                                    SOVERSION ${XC_CURRENT})
if(${BUILD_SHARED_LIBS})
    target_link_libraries(xc PRIVATE ${LIBC_INTERJECT})
    if(APPLE)
        set_target_properties(xc PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()
endif()

if(ENABLE_FORTRAN)
  enable_language(Fortran)
  add_library(xcf90 src/libxc_master.F90 gen_funcidx/libxc_funcs.f90)
  target_link_libraries(xcf90 xc)
  set_target_properties(xcf90 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
endif(ENABLE_FORTRAN)

if(ENABLE_FORTRAN03)
  # Fortran is already enabled above
  set(CMAKE_Fortran_SOURCE_FILE_EXTENSIONS ${CMAKE_Fortran_SOURCE_FILE_EXTENSIONS} "f03;F03")
  set_source_files_properties(src/libxc_master.F03 PROPERTIES LANGUAGE Fortran)
  add_library(xcf03 src/libxc_master.F03)
  target_link_libraries(xcf03 xc)
  set_target_properties(xcf03 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
endif(ENABLE_FORTRAN03)

# run get_funcs.pl to generate headers for xc inclusion
find_package(Perl REQUIRED)
set(gen_dir "${PROJECT_BINARY_DIR}/gen_funcidx")
execute_process(
    COMMAND ${CMAKE_COMMAND} -E make_directory ${gen_dir}
    TIMEOUT 5
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
execute_process(
    COMMAND ${PERL_EXECUTABLE} scripts/get_funcs.pl ${src_prefix} ${gen_dir}
    TIMEOUT 60
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

add_executable(xc-info "${src_prefix}/xc-info.c")
target_link_libraries(xc-info xc)

add_executable(xc-threshold "${src_prefix}/xc-threshold.c")
target_link_libraries(xc-threshold xc)


include_directories(${PROJECT_SOURCE_DIR}/${src_prefix}  # for util.h
                    ${PROJECT_BINARY_DIR}/${src_prefix}  # for xc.h
                    ${PROJECT_BINARY_DIR}  # for xc_version.h, config.h
                    ${gen_dir})  # for xc_funcs.h

if(BUILD_TESTING)
    enable_testing ()
    add_subdirectory(testsuite)
endif()

# <<<  Install  >>>

# by default, headers NOT namespace protected
install(FILES ${PROJECT_BINARY_DIR}/${src_prefix}/xc.h
              ${gen_dir}/xc_funcs.h
              ${PROJECT_BINARY_DIR}/xc_version.h
              ${PROJECT_SOURCE_DIR}/${src_prefix}/xc_funcs_removed.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${NAMESPACE_INSTALL_INCLUDEDIR})
install(TARGETS xc xc-info xc-threshold
        EXPORT "${PN}Targets"
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
if(ENABLE_FORTRAN)
  install(TARGETS xcf90
    EXPORT "${PN}Targets"
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif(ENABLE_FORTRAN)
if(ENABLE_FORTRAN03)
  install(TARGETS xcf03
    EXPORT "${PN}Targets"
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif(ENABLE_FORTRAN03)
# <<<  Export Interface  >>>

target_compile_definitions(xc INTERFACE USING_${PN})
target_include_directories(xc INTERFACE
                           $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# <<<  Export Config  >>>

# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
set(CMAKECONFIG_INSTALL_DIR "share/cmake/${PN}")
configure_package_config_file(cmake/${PN}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PN}Config.cmake"
                              INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PN}ConfigVersion.cmake
                                 VERSION ${${PN}_VERSION}
                                 COMPATIBILITY AnyNewerVersion)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PN}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PN}ConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})
install(EXPORT "${PN}Targets"
        NAMESPACE "${PN}::"
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(FILES ${PROJECT_BINARY_DIR}/libxc.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/libxc.pc)

=== testsuite/CMakeLists.txt ===
link_libraries(xc)
add_executable(xc-consistency xc-consistency.c)
add_executable(xc-error xc-error.c)
add_executable(xc-get_data xc-get_data.c)
add_executable(xc-regression xc-regression.c)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/workdir)
set(_sdirs lda_x lda_c lda_xc lda_k gga_x gga_c gga_xc gga_k mgga_x mgga_c mgga_xc mgga_k hyb_gga_x hyb_gga_xc hyb_mgga_x hyb_mgga_xc)
foreach(_sdir ${_sdirs})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir})
    file(GLOB _bz2s RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "regression/${_sdir}/*.bz2")
    foreach(_bz2 ${_bz2s})
        # get test name
        get_filename_component(_file ${_bz2} NAME)
        string(REPLACE "." ";" _list ${_file})
        separate_arguments(_list)
        list(GET _list 0 func)
        list(GET _list 1 system)
        list(GET _list 2 spin)
        list(GET _list 3 order)
        if(${spin} STREQUAL "unpol")
            set(nspin 1)
    	else()
            set(nspin 2)
        endif()
	if(${order} EQUAL 0)
	    set(tol "5e-8")
        elseif(${order} EQUAL 1)
            set(tol "5e-5")
        elseif(${order} EQUAL 2)
            set(tol "5e-4")
	endif()
        set(refname "${func}.${system}.${spin}.${order}")

        # extract reference values
        execute_process(COMMAND bunzip2 -c "${CMAKE_CURRENT_SOURCE_DIR}/regression/${_sdir}/${refname}.bz2"
                    	OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}_ref")

        # this is properly the real test, but presumably it'll get rebuilt if libxc changes
        add_custom_command(TARGET xc-regression POST_BUILD
                           COMMAND xc-regression ARGS ${func} ${nspin} ${order} "${CMAKE_CURRENT_SOURCE_DIR}/input/${system}" "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}" ">" "/dev/null")

        # the testing itself
        add_test(NAME "${func}-${system}-${spin}-${order}"
             	 COMMAND xc-error "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}" "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}_ref" "${tol}")
    endforeach()
endforeach()

# Warning: I don't know how to make a test fail, so proper capture of failure not confirmed

## libxc 2.0.2

=== debian/changelog ===
libxc (2.0.2-1ubuntu1) trusty; urgency=medium

  * Use dh-autoreconf to get new libtool macros for ppc64el.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 06 Jan 2014 01:42:51 -0500

libxc (2.0.2-1) unstable; urgency=low

  * Initial release (Closes: #602110).

 -- Michael Banck <mbanck@debian.org>  Mon, 29 Jul 2013 10:57:27 +0200

=== debian/control ===
Source: libxc
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>> 8), dh-autoreconf, gfortran
Standards-Version: 3.9.4
Homepage: http://www.tddft.org/programs/octopus/wiki/index.php/Libxc
Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/libxc/
Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/libxc/

Package: libxc1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library of Exchange-Correlation Functionals
 LibXC is a library of exchange-correlation (XC) functionals for
 density-functional theory (DFT). The aim is to provide a portable, well
 tested and reliable set of exchange and correlation functionals that
 can be used by other codes. Supported XC functionals include:
 .
  * Local Density Approximation (LDA) functionals including Slater exchange,
    and VWN, Perdew-Zunger or PADE correlation.
  * Generalized Gradient Approximation (GGA) XC functionals including PBE,
    PW91, BLYP, HCTH93, HCTH120, HCTH147, HCTH407, as well as B88 exchange and
    LYP or P86 correlation.
  * Hybrid XC functionals including B3LYP, PBE0, B97, X3LYP, BHANDH, HSE03
    and HSE06.
  * Meta-GGA XC functionals including TPSS, M05 and M06.

Package: libxc-dev
Architecture: any
Section: libdevel
Depends: libxc1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Library of Exchange-Correlation Functionals (development files)
 LibXC is a library of exchange-correlation (XC) functionals for
 density-functional theory (DFT). The aim is to provide a portable, well
 tested and reliable set of exchange and correlation functionals that
 can be used by other codes.
 .
 This package contains the static library, the C headers and the Fortran
 modules necessary for developers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export FCCPP=/lib/cpp -C -ansi -ffreestanding

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared

override_dh_auto_test:
	-dh_auto_test -- -k

## libxc 2.0.3

=== debian/changelog ===
libxc (2.0.3-1) unstable; urgency=low

  * New upstream release.

  [ Daniel Leidert ]
  * debian/compat: Set to 9.
  * debian/control: Enabled multi-arch support.
    (Vcs-Browser, Vcs-Svn): Fixed lintian warning.
    (Build-Depends): Increased debhelper version. Added dh-autoreconf
    (closes: #734559).
  * debian/copyright: Minor fix.
  * debian/libxc1.install, debian/libxc-dev.install: Adjusted after enabling
    multi-arch support.
  * debian/rules: Added autoreconf addon and enabled parallel building. Export
    FCFLAGS properly for hardening.
  * debian/watch: Added.

 -- Debichem Team <debichem-devel@lists.alioth.debian.org>  Mon, 24 Feb 2014 16:56:22 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export FCCPP   = /lib/cpp -C -ansi -ffreestanding
export FCFLAGS = $(shell dpkg-buildflags --get FFLAGS) -pipe -funroll-loops -ffast-math -ffree-line-length-none

%:
	dh $@ --with autoreconf --parallel

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared

override_dh_auto_test:
	-dh_auto_test -- -k

## libxc 2.1.1

=== debian/changelog ===
libxc (2.1.1-1) unstable; urgency=medium

  * New upstream point release.

 -- Michael Banck <mbanck@debian.org>  Sat, 29 Nov 2014 18:02:57 +0100

libxc (2.1.0-2) unstable; urgency=medium

  * debian/patches/fix_static_initialisation.patch: New patch, fixes FTBFS
    errors due to invalid static initialisations on some architectures.
  * debian/rules: Removed parallel option, as it seems to lead to FTBFS errors
    on some autobuilders.

 -- Michael Banck <mbanck@debian.org>  Sun, 12 Oct 2014 20:29:27 +0200

libxc (2.1.0-1) unstable; urgency=medium

  * New upstream release.

  [ Daniel Leidert ]
  * debian/copyright: Updated and moved to DEP5.
  * debian/rules: Run dh_install with --list-missing.
  * debian/patches/fix_underlinkage.patch: Added.
    - Add missing -lm to fix underlinkage of the library.
  * debian/patches/testsuite_support_tmpdir.patch: Adjusted.
  * debian/patches/series: Adjusted.

  [ Michael Banck ]
  * debian/upstream: Moved to debian/upstream/metadata.

 -- Michael Banck <mbanck@debian.org>  Sun, 12 Oct 2014 00:28:14 +0200

## libxc 2.1.2

=== debian/changelog ===
libxc (2.1.2-1) unstable; urgency=medium

  * New upstream point release.
  * The following functionals had bugs fixed:
    - GGA: X_LB, X_LBM (bug affected unpolarized version only)
    - MGGA: C_REVTPSS, C_M08_HX, C_M08_SO, C_M11, C_M11_L
    - all HYB_GGA and HYB_MGGA (missing variable initialization that could
      cause Libxc to return wrong mixing parameters) 
  * debian/upstream/metadata: Added ArXiv PDF eprint.

 -- Michael Banck <mbanck@debian.org>  Wed, 23 Sep 2015 21:15:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: libxc
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>> 8), dh-autoreconf, gfortran
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>> 9), dh-autoreconf, gfortran
+Standards-Version: 3.9.5
 Homepage: http://www.tddft.org/programs/octopus/wiki/index.php/Libxc
-Vcs-Browser: http://svn.debian.org/wsvn/debichem/unstable/libxc/
-Vcs-Svn: svn://svn.debian.org/svn/debichem/unstable/libxc/
+Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/libxc/
+Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/libxc/
 
 Package: libxc1
 Architecture: any
+Multi-Arch: same
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Library of Exchange-Correlation Functionals
  LibXC is a library of exchange-correlation (XC) functionals for
  density-functional theory (DFT). The aim is to provide a portable, well
@@ -32,7 +32,7 @@
 Package: libxc-dev
 Architecture: any
 Section: libdevel
-Depends: libxc1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libxc1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Library of Exchange-Correlation Functionals (development files)
  LibXC is a library of exchange-correlation (XC) functionals for
  density-functional theory (DFT). The aim is to provide a portable, well

## libxc 3.0.0

=== debian/changelog ===
libxc (3.0.0-1build1) artful; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Aug 2017 17:19:20 +0000

libxc (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix_underlinkage.patch: Removed, no longer needed.
  * debian/patches/fix_static_initialisation.patch: Refreshed.
  * debian/control (libxc1): Renamed package to libxc4, adjust references.
  * debian/libxc1.install: Renamed to ...
  * debian/libxc4.install: ... this.
  * debian/libxc4.symbols: New file.

 -- Michael Banck <mbanck@debian.org>  Sun, 29 May 2016 13:21:17 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/libxc/
 Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/libxc/
 
-Package: libxc1
+Package: libxc4
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -32,7 +32,7 @@
 Package: libxc-dev
 Architecture: any
 Section: libdevel
-Depends: libxc1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libxc4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Library of Exchange-Correlation Functionals (development files)
  LibXC is a library of exchange-correlation (XC) functionals for
  density-functional theory (DFT). The aim is to provide a portable, well

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,13 @@
 export FCFLAGS = $(shell dpkg-buildflags --get FFLAGS) -pipe -funroll-loops -ffast-math -ffree-line-length-none
 
 %:
-	dh $@ --with autoreconf --parallel
+	dh $@ --with autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-shared
 
 override_dh_auto_test:
 	-dh_auto_test -- -k
+
+override_dh_install:
+	dh_install --list-missing

=== debian/watch ===
version=3
opts=\
downloadurlmangle=s#.*/Libxc_([\d.]+)$#http://www.tddft.org/programs/octopus/down.php?file=libxc/libxc-$1.tar.gz#g,\
filenamemangle=s#.*/Libxc_([\d.]+)$#libxc-$1.tar.gz#g \
 http://www.tddft.org/programs/octopus/wiki/index.php/Libxc:download ^.*/Libxc_([\d.]+)$

## libxc 4.2.3

=== debian/changelog ===
libxc (4.2.3-3) unstable; urgency=medium

  * debian/patches/disable_lda_c_pk09.patch: New patch, disables the lda_c_pk09
    functional.
  * debian/rules (override_dh_auto_clean): Remove lda_c_pk09-specific testsuite
    files.
  * debian/libxc5.symbols: Updated.

 -- Michael Banck <mbanck@debian.org>  Sun, 23 Dec 2018 10:48:15 +0100

libxc (4.2.3-2) unstable; urgency=medium

  * debian/rules: Use -g1 in CFLAGS and FFLAGS on mips/mipsel dues to
    autobuilder out-of-memory issues during compilation.

 -- Michael Banck <mbanck@debian.org>  Fri, 21 Dec 2018 22:59:42 +0100

libxc (4.2.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Updated.
  * debian/rules: Force buildsystem to autoconf.
  * debian/libxc-dev.install: Wildcard pkg-config files to install.
  * debian/patches/fix_static_initialisation.patch: Refreshed.
  * debian/patches/cmake_support.patch: Removed, no longer needed.
  * debian/control, debian/libxc4.install, debian/libxc4.symbols: Bump to
    libxc5 according to SONAME change.
  * debian/libxc5.symbols: Updated.
  * debian/patches/fix_cmake_pkgconfig.patch: New patch, fixes the installation
    of libxc.pc in the CMake build system.
  * debian/control (Build-Depends): Added cmake.
  * debian/rules: Build via cmake as well.
  * debian/rules: Enable parallel build.
  * debian/libxc-dev.install: Ship CMake and binary support files.
  * debian/patches/fix_config_h_include.patch: New patch, removes include of
    config.h from xc.h, taken from upstream commit 8a7cb2e2.

 -- Michael Banck <mbanck@debian.org>  Sun, 16 Dec 2018 00:53:38 +0100

libxc (3.0.0-2) unstable; urgency=medium

  * debian/patches/cmake_support.patch: New patch, adding CMake build support,
    taken from the psi4 upstream fork.

 -- Michael Banck <mbanck@debian.org>  Sat, 19 May 2018 17:29:37 +0200

## libxc 4.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_policy(SET CMP0048 NEW)  # project_VERSION* variables populated from project(... VERSION x.x.x) string
 project(Libxc
-        VERSION 4.2.3
+        VERSION 4.3.4
         LANGUAGES C)
 set(Libxc_AUTHORS      "Miguel A.L. Marques and others")
 set(Libxc_DESCRIPTION  "Exchange-correlation functionals for density-functional theory")
@@ -26,9 +26,6 @@
   "-xHost" "-march=native")
 option_with_print(ENABLE_FORTRAN "Build Fortran 90 interface" OFF)
 option_with_print(ENABLE_FORTRAN03 "Build Fortran 2003 interface" OFF)
-if((${ENABLE_FORTRAN03}) AND NOT ${ENABLE_FORTRAN})
-    message(FATAL_ERROR "ENABLE_FORTRAN must be enabled if ENABLE_FORTRAN03 is enabled!")
-endif()
 
 ######################### Process & Validate Options ###########################
 include(autocmake_safeguards)
@@ -42,7 +39,15 @@
 
 # link -lm only if necessary
 find_package(StandardMathLibraryC)
-
+# check if cbrt exists and declare HAVE_CBRT if it does
+check_c_source_compiles (
+  "#include <math.h>
+int main() {
+  return (int)(cbrt(0.8));
+}" HAVE_CBRT)
+if (HAVE_CBRT)
+  add_definitions (-DHAVE_CBRT)
+endif (HAVE_CBRT)
 # <<<  Build  >>>
 
 # repurpose xc_version from Make for CMake
@@ -65,7 +70,8 @@
   endif()
 endforeach()
 set(${PROJECT_NAME}_SOVERSION ${XC_CURRENT}:${XC_REVISION}:${XC_AGE})
-message(STATUS "Libxc SO ${${PROJECT_NAME}_SOVERSION}")
+math(EXPR ${PROJECT_NAME}_SOMAJOR "${XC_CURRENT} - ${XC_AGE}")
+message(STATUS "Libxc SO Full ${${PROJECT_NAME}_SOVERSION} Major ${${PROJECT_NAME}_SOMAJOR}")
 
 set(raw_sources_list
 bessel.c
@@ -284,6 +290,15 @@
 set(src_prefix "src/")
 string(REGEX REPLACE "([^;]+)" "${src_prefix}\\1" sources_list "${raw_sources_list}")
 
+set(raw_sources_list_f90
+    src/xc_f.c
+    src/libxc_master.F90
+    gen_funcidx/libxc_funcs.f90
+)
+set(raw_sources_list_f03
+    src/libxc_master.F03
+)
+
 # when headers namespaced, xc_version include in xc.h needs to be local, not
 #   system to be found
 file(READ ${src_prefix}xc.h _src_contents)
@@ -295,7 +310,7 @@
 target_link_libraries(xc INTERFACE ${STANDARD_MATH_LIBRARY})
 set_target_properties(xc PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC}
                                     COMPILE_FLAGS "-std=c99"
-                                    SOVERSION ${XC_CURRENT})
+                                    SOVERSION ${${PROJECT_NAME}_SOMAJOR})
 if(${BUILD_SHARED_LIBS})
     target_link_libraries(xc PRIVATE ${LIBC_INTERJECT})
     if(APPLE)
@@ -303,21 +318,32 @@
     endif()
 endif()
 
-if(ENABLE_FORTRAN)
-  enable_language(Fortran)
-  add_library(xcf90 src/libxc_master.F90 gen_funcidx/libxc_funcs.f90)
-  target_link_libraries(xcf90 xc)
-  set_target_properties(xcf90 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
-endif(ENABLE_FORTRAN)
-
-if(ENABLE_FORTRAN03)
-  # Fortran is already enabled above
-  set(CMAKE_Fortran_SOURCE_FILE_EXTENSIONS ${CMAKE_Fortran_SOURCE_FILE_EXTENSIONS} "f03;F03")
-  set_source_files_properties(src/libxc_master.F03 PROPERTIES LANGUAGE Fortran)
-  add_library(xcf03 src/libxc_master.F03)
-  target_link_libraries(xcf03 xc)
-  set_target_properties(xcf03 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
-endif(ENABLE_FORTRAN03)
+if(ENABLE_FORTRAN OR ENABLE_FORTRAN03)
+    enable_language(Fortran)
+    include(FortranCInterface)
+    # This is needed for the mangling
+    add_definitions(-DHAVE_FORTRAN)
+
+    add_library(xcf90 ${raw_sources_list_f90})
+    target_link_libraries(xcf90 xc)
+    set_target_properties(xcf90 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
+    target_compile_definitions(xcf90
+      PUBLIC
+        CC_FORTRAN_INT=int
+        )
+
+    FortranCInterface_HEADER(Libxc_MANGLE.h
+                             MACRO_NAMESPACE "FC_FUNC_"
+                             SYMBOL_NAMESPACE "FC_FUNC_")
+
+    if(ENABLE_FORTRAN03)
+        set(CMAKE_Fortran_SOURCE_FILE_EXTENSIONS ${CMAKE_Fortran_SOURCE_FILE_EXTENSIONS} "f03;F03")
+        set_source_files_properties(${raw_sources_list_f03} PROPERTIES LANGUAGE Fortran)
+        add_library(xcf03 ${raw_sources_list_f03})
+        target_link_libraries(xcf03 xc)
+        set_target_properties(xcf03 PROPERTIES POSITION_INDEPENDENT_CODE ${BUILD_FPIC})
+    endif()
+endif()
 
 # run get_funcs.pl to generate headers for xc inclusion
 find_package(Perl REQUIRED)
@@ -344,8 +370,15 @@
                     ${gen_dir})  # for xc_funcs.h
 
 if(BUILD_TESTING)
-    enable_testing ()
-    add_subdirectory(testsuite)
+    find_program(BZip2_EXECUTABLE
+             NAMES bzip2
+             DOC "Path to zipping utility")
+    if(BZip2_EXECUTABLE)
+        enable_testing ()
+        add_subdirectory(testsuite)  
+    else()
+        message(FATAL_ERROR "Install `bzip2` command to enable tests")
+    endif()
 endif()
 
 # <<<  Install  >>>
@@ -361,20 +394,28 @@
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
         ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
         LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
-if(ENABLE_FORTRAN)
-  install(TARGETS xcf90
-    EXPORT "${PN}Targets"
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
-endif(ENABLE_FORTRAN)
-if(ENABLE_FORTRAN03)
-  install(TARGETS xcf03
-    EXPORT "${PN}Targets"
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
-endif(ENABLE_FORTRAN03)
+if(ENABLE_FORTRAN OR ENABLE_FORTRAN03)
+    install(TARGETS xcf90
+            EXPORT "${PN}Targets"
+            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
+    install(FILES "${PROJECT_BINARY_DIR}/libxc_funcs_m.mod"
+                  "${PROJECT_BINARY_DIR}/xc_f90_lib_m.mod"
+                  "${PROJECT_BINARY_DIR}/xc_f90_types_m.mod"
+            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${NAMESPACE_INSTALL_INCLUDEDIR})
+
+    if(ENABLE_FORTRAN03)
+        install(TARGETS xcf03
+                EXPORT "${PN}Targets"
+                RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+                ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+                LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
+        install(FILES "${PROJECT_BINARY_DIR}/xc_f03_lib_m.mod"
+                DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}${NAMESPACE_INSTALL_INCLUDEDIR})
+    endif()
+endif()
+
 # <<<  Export Interface  >>>
 
 target_compile_definitions(xc INTERFACE USING_${PN})
@@ -392,11 +433,3 @@
                                  VERSION ${${PN}_VERSION}
                                  COMPATIBILITY AnyNewerVersion)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PN}Config.cmake
-              ${CMAKE_CURRENT_BINARY_DIR}/${PN}ConfigVersion.cmake
-        DESTINATION ${CMAKECONFIG_INSTALL_DIR})
-install(EXPORT "${PN}Targets"
-        NAMESPACE "${PN}::"
-        DESTINATION ${CMAKECONFIG_INSTALL_DIR})
-
-install(FILES ${PROJECT_BINARY_DIR}/libxc.pc
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/libxc.pc)

=== testsuite/CMakeLists.txt ===
--- 
+++ 
@@ -37,12 +37,18 @@
                     	OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}_ref")
 
         # this is properly the real test, but presumably it'll get rebuilt if libxc changes
-        add_custom_command(TARGET xc-regression POST_BUILD
-                           COMMAND xc-regression ARGS ${func} ${nspin} ${order} "${CMAKE_CURRENT_SOURCE_DIR}/input/${system}" "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}" ">" "/dev/null")
 
-        # the testing itself
-        add_test(NAME "${func}-${system}-${spin}-${order}"
-             	 COMMAND xc-error "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}" "${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}_ref" "${tol}")
+        # generate test values
+        set(test "${func}-${system}-${spin}-${order}")
+        add_test(NAME ${test}-run
+                 COMMAND xc-regression ${func} ${nspin} ${order} ${CMAKE_CURRENT_SOURCE_DIR}/input/${system} ${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname})
+        set_tests_properties(${test}-run PROPERTIES TIMEOUT 1)
+
+        # checke the tests values against the reference values
+        add_test(NAME ${test}-check
+                 COMMAND xc-error ${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname} ${CMAKE_CURRENT_BINARY_DIR}/workdir/${_sdir}/${refname}_ref ${tol})
+        set_tests_properties(${test}-check PROPERTIES DEPENDS ${test}-run)
+
     endforeach()
 endforeach()

=== debian/changelog ===
libxc (4.3.4-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:37 +0100

libxc (4.3.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/testsuite_support_tmpdir.patch,
    debian/patches/fix_static_initialisation.patch: Refreshed.
  * debian/patches/fix_cmake_pkgconfig.patch: Removed, applied upstream.
  * debian/patches/fix_config_h_include.patch: Likewise.
  * debian/patches/disable_lda_c_pk09.patch: Refreshed.
  * debian/libxc5.symbols: Updated.
  * debian/copyright, debian/upstream/metadata: Updated project homepage to
    Gitlab.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Nov 2019 17:45:13 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>> 9), dh-autoreconf, gfortran
+Build-Depends: cmake, debhelper (>> 9), dh-autoreconf, gfortran
 Standards-Version: 3.9.5
 Homepage: http://www.tddft.org/programs/octopus/wiki/index.php/Libxc
-Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/libxc/
-Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/libxc/
+Vcs-Browser: https://salsa.debian.org/debichem-team/libxc
+Vcs-Git: https://salsa.debian.org/debichem-team/libxc.git
 
-Package: libxc4
+Package: libxc5
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -32,7 +32,7 @@
 Package: libxc-dev
 Architecture: any
 Section: libdevel
-Depends: libxc4 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libxc5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Library of Exchange-Correlation Functionals (development files)
  LibXC is a library of exchange-correlation (XC) functionals for
  density-functional theory (DFT). The aim is to provide a portable, well

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
	DEBUG=-g1
else
	DEBUG=
endif

export FCCPP   = /lib/cpp -C -ansi -ffreestanding
export FCFLAGS = $(shell dpkg-buildflags --get FFLAGS) $(DEBUG) -pipe -funroll-loops -ffast-math -ffree-line-length-none
export CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(DEBUG)

%:
	dh $@ --parallel --with autoreconf --buildsystem autoconf

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem cmake
	-rm -f testsuite/regression/lda_c/lda_c_pk09.*

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared
	dh_auto_configure --buildsystem cmake --	\
		-DCMAKE_BUILD_TYPE=Release		\

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem cmake

override_dh_auto_test:
	-dh_auto_test -- -k
	-dh_auto_test --buildsystem cmake -- -k

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem cmake
